local possVersion = "2.1b-PortBR"
local possAboutTxt =
[[---------- ]].."\131"..[[Possession]].."\128"..[[ ----------

   Versao: ]].."\130"..possVersion.."\128\n"..[[
Criado por: ]].."\130"..[[Rapidgame7]].."\128\n"..[[
Modificado por: ]].."\130"..[[Xelork]].."\128\n"..[[
Traduzido por: ]].."\130"..[[Solidus]].."\128\n"..[[

]]

--[[
If you modified this file for your own purposes, PLEASE do the following steps:
1) At the end of the filename, after the version designation, add "-mod".
For example, "poss6.9-mod".
Do the same for the variable "possVersion".
2) Add a "Modified by" section right after "Created by", and delete the text about the thanks n stuff or change it

and that's it ok bye
]]

COM_AddCommand("poss_about", function(p)
	CONS_Printf(p, possAboutTxt)
end, 0)


local cv_shootemerald = CV_RegisterVar({"poss_shootemerald", "Yes", CV_NETVAR|CV_SHOWMODIF, CV_YesNo})
local cv_tossemerald = CV_RegisterVar({"poss_tossemerald", "Normal", CV_NETVAR|CV_SHOWMODIF, {No = 0, InPlace = 1, Normal = 2} })
local cv_emeraldharm = CV_RegisterVar({"poss_emeraldharm", "Yes", CV_NETVAR|CV_SHOWMODIF, CV_YesNo})
local cv_deathmomentum = CV_RegisterVar({"poss_deathmomentum", "Yes", CV_NETVAR|CV_SHOWMODIF, CV_YesNo})

local cv_holdtime = CV_RegisterVar({"poss_holdtime", "50", CV_NETVAR|CV_SHOWMODIF, {MIN = 1, MAX = 9999}})
-- Hold the rock this amount of seconds to do the win

local cv_tospawntime = CV_RegisterVar({"poss_spawntime", "5", CV_NETVAR|CV_SHOWMODIF, {MIN = 1, MAX = 9999}})
-- Wait some time before spawning the rock

local cv_grasptimeMinTime = CV_RegisterVar({"poss_grasptime_mintime", "5", CV_NETVAR|CV_SHOWMODIF, {MIN = 1, MAX = 9999}})
local cv_grasptimeDecrease = CV_RegisterVar({"poss_grasptime_decrement", "1", CV_NETVAR|CV_SHOWMODIF, {MIN = 1, MAX = 9999}})
local cv_grasptimeStart = CV_RegisterVar({"poss_grasptime_start", "180", CV_NETVAR|CV_SHOWMODIF, {MIN = 0, MAX = 9999}})
local cv_grasptime = CV_RegisterVar({"poss_grasptime", "Off", CV_NETVAR|CV_SHOWMODIF, CV_OnOff})

local cv_globaltimer = CV_RegisterVar({"poss_globaltimer", "Off", CV_NETVAR|CV_SHOWMODIF, {Off = 0, On = 1, Team = 2} })

local cv_ringspawner = CV_RegisterVar({"poss_ringspawnpoint", "No", CV_NETVAR, CV_YesNo})

local cv_possenabled = CV_RegisterVar({"possession", "On", CV_NETVAR|CV_SHOWMODIF, CV_OnOff})


--local shiftx = CV_RegisterVar({"shiftx", "1", nil, {MIN = -320, MAX = 640}})
--local shifty = CV_RegisterVar({"shifty", "1", nil, {MIN = -200, MAX = 400}})

local inPossRound = false
local teamPossRound = false
local playerWithRock
local oldPlayerWithRock
local oldPlayerWithRockStats = {}
local rockMobj
local spawnLocations = {}
local heldTime = 0
local heldTimeBlue = 0
local graceMode = 0
local graceModeDecrease = 0
local _dummy1 = 0
local _endrnd = 0

addHook("NetVars", function(x)
	inPossRound = x($)
	teamPossRound = x($)
	playerWithRock = x($)
	oldPlayerWithRock = x($)
	oldPlayerWithRockStats = x($)
	rockMobj = x($)
	spawnLocations = x($)
	heldTime = x($)
	heldTimeBlue = x($)
	graceMode = x($)
	graceModeDecrease = x($)
	_dummy1 = x($)
	_endrnd = x($)
end)

-- A few functions for you people that like to hook onto mods lel
rawset(_G, "POSS_InPossRound", function()
	return inPossRound
end)
rawset(_G, "POSS_GetPlayerWithRock", function()
	return playerWithRock
end)

local function TCC(val)
	if not (val and val.valid and val.mo and val.mo.valid) then return "\132" end
	val = val.ctfteam
	if G_GametypeHasTeams() then
		if val == 0 then return "\134"
		elseif val == 1 then return "\133"
		elseif val == 2 then return "\132"
		else return "\129" end
	else return "\130" end
end

local function noshieldStuff(monitor)
	S_StartSound(monitor.target, sfx_lose)
	STATUS_BroadcastToPlayer(monitor.target.player, "^7You can't have shields\n^7with the Emerald", 70, 35, 0)
end

-- huge copypasta ahead - better than letting players know the hard way that they can't get shields
function A_WhateverShield(actor)
	if inPossRound and actor.target and actor.target.valid and actor.target.player and actor.target.player.valid -- gotta make sure
	and playerWithRock == actor.target.player then
		noshieldStuff(actor) -- die lol
		return
	end
	super(actor)
end
A_ForceShield = A_WhateverShield
A_BombShield = A_WhateverShield
A_JumpShield = A_WhateverShield
A_RingShield = A_WhateverShield
A_WaterShield = A_WhateverShield
A_PityShield = A_WhateverShield --huh

addHook("MapLoad", function()
	if leveltime < 1 and inPossRound and (gametype == GT_TEAMMATCH or gametype == GT_MATCH) then
		for mapthing in mapthings.iterate do
			if mapthing.type == 321 or mapthing.type == 667 or (cv_ringspawner.value == 1 and mapthing.type == 300) then
				local subsector = R_PointInSubsector(mapthing.x*FRACUNIT, mapthing.y*FRACUNIT)
				local realz = subsector.sector.floorheight
				local lilTable = {
					x = mapthing.x*FRACUNIT,
					y = mapthing.y*FRACUNIT,
					--z = mapthing.z
					z = (realz) + ( (mapthing.options>>4) * FRACUNIT) -- mapthing.z returns 0 in team match (for emerald spawnpoints)
				}
				--print("TOTZ:    "..lilTable.z/FRACUNIT)
				--print("THINGZ:  "..mapthing.z*FRACUNIT)
				--print("THINGOPT:"..mapthing.options)
				--print("THINGO<4:"..mapthing.options<<4)
				--print("THINGO>4:"..mapthing.options>>4)
				--print("SECTORZ: "..realz/FRACUNIT)
				table.insert(spawnLocations, lilTable)
				if mapthing.type == 323 and mapthing.mobj then
					P_RemoveMobj(mapthing.mobj)
				end
			end
		end
	end
end)

addHook("ThinkFrame", function()
	if inPossRound and (gametype ~= GT_MATCH and gametype ~= GT_TEAMMATCH) then inPossRound = false end
	if inPossRound then
		if cv_globaltimer.value ~= 2 or gametype ~= GT_TEAMMATCH then
			teamPossRound = false
		end
		--print(rockMobj)
		if (cv_tospawntime.value*TICRATE - leveltime) <= 0
		and not rockMobj -- If there is no rock object around
		and (not playerWithRock or not playerWithRock.valid) -- And nobody is holding the rock
		and (not oldPlayerWithRock or not oldPlayerWithRock.valid) then -- And nobody held the rock previously
			_dummy1 = P_RandomRange(1, #spawnLocations)
			local a = spawnLocations[_dummy1]
			if not a then print("There are no emerald spawnpoints in this map! Have you disabled emeralds in netgames, or the map doesn't have emerald spawnpoints?");inPossRound = false;return end
			rockMobj = P_SpawnMobj(a.x, a.y, a.z, MT_PSSE_THING)
			S_StartSound(rockMobj, sfx_pspawn)
			STATUS_Broadcast("A ^3Esmeralda Mestre^0 apareceu", 175, 70, flags)
			print("A \131Esmeralda Mestre\128 apareceu!")
		end
		
		-- Winning code
		-- teamPossRound
		if (cv_holdtime.value*TICRATE - heldTime) < 0 then
			heldTime = cv_holdtime.value*TICRATE
		end
		if teamPossRound and (cv_holdtime.value*TICRATE - heldTimeBlue) < 0 then
			heldTimeBlue = cv_holdtime.value*TICRATE
		end
		
		
		
		local function fixTime(var)
			return cv_holdtime.value*TICRATE - var
		end
		
		if ( //FFA COND
		(not teamPossRound and fixTime(heldTime) == 0)
		or   //TEAM COND
		(teamPossRound and ( fixTime(heldTime) == 0 or fixTime(heldTimeBlue) == 0 ) )
		) and not _endrnd then
			_endrnd = true
			
			if not teamPossRound then
				print(TCC(playerWithRock)..playerWithRock.name.."\128 possuiu a \131Esmeralda Mestre\128 e venceu o round!")
			else
				local redWin = fixTime(heldTime) == 0
				local blueWin = fixTime(heldTimeBlue) == 0
				local teamTxt = redWin and "red" or blueWin and "blue" or "unknown team"
				
				print("The "..TCC(playerWithRock)..teamTxt.." team\128 possessed the \131Master Emerald\128 and won the round!")
			end
			playerWithRock.score = 0
			P_AddPlayerScore(playerWithRock, 420420420)
			--playerWithRock.score = 666666666 -- lotsa score amirite
			G_ExitLevel()
			--COM_BufInsertText(server, "exitlevel")
		end
		
		
		
		if cv_globaltimer.value == 0 and cv_grasptime.value and leveltime > cv_grasptimeStart.value*TICRATE and graceMode == 0 then
			graceMode = 1
			S_StartSound(nil, sfx_gracet)
			print("\131Grasp time\128 is over!")
			STATUS_Broadcast("^5Grasp time is over!", 350, 70, flags)
		end
	end
end)

addHook("TouchSpecial", function(m, mt)
	--print("Execute")
	if m and m.valid and mt and mt.valid and mt.player
	and mt.player.playerstate ~= PST_DEAD then -- Picked up!
		local totspeed = abs(m.momx) + abs(m.momy) + abs(m.momz)
		--print(totspeed/FRACUNIT)
		
		if mt.player.tossdelay <= 0 then
		local tolerance = cv_emeraldharm.value == 1 and 69*FRACUNIT or INT32_MAX
		if totspeed < tolerance then
			print(TCC(mt.player)..mt.player.name.."\128 pegou a \131Esmeralda Mestre\128!")
			for player in players.iterate do
			if player and player.valid and player.mo and player.mo.valid then
				if player.mo == mt then
					STATUS_BroadcastToPlayer(player, "Voce pegou a ^3Esmeralda Mestre^0", 105, 35, flags)
				else
					STATUS_BroadcastToPlayer(player, "A ^3Esmeralda Mestre^0 foi pega", 105, 35, flags)
				end
			end
			end
			--S_ChangeMusic("COLLEC", true, mt.player)
			-- Was planning on adding cool music for when you collect the emmie
			-- but the music i wanted bloated the file size
			-- so i went full "nah screw it"
			P_RemoveMobj(m)
			playerWithRock = mt.player
			oldPlayerWithRock = mt.player
			rockMobj = nil
			P_SpawnMobj(mt.x, mt.y, mt.z, MT_PSSE_INDICATOR)
			S_StartSound(nil, sfx_pgrab)
			if cv_grasptime.value and graceMode == 1 and not cv_globaltimer.value then
				heldTime = $ + (graceModeDecrease)
			end
			return true
		else
			local function hitMove()
				mt.momx = m.momx
				mt.momy = m.momy
				mt.momz = m.momz
				--print("Moving")
			end
			if not mt.player.powers[pw_flashing] and not mt.player.powers[pw_invulnerability] then
				P_DamageMobj(mt, m, m, 1)
				--print("blyat hit")
				hitMove()
			end
			if mt.player.powers[pw_invulnerability] then
				hitMove()
			end
			return true
		end
		else
			return true
		end
	else
		--print(m)
		--print(m.valid)
		--print(mt)
		--print(mt.valid)
		--print(mt.player.powers[pw_flashing])
		--print(mt.player.playerstate)
		error("please send help")
		return false
	end
end, MT_PSSE_THING)

local function playerSpawnsEmerald(m, keepmomentum, bump) -- For when player dies or willingly tosses emerald
	local bumpval = 8*FRACUNIT
	if m == nil then m = oldPlayerWithRockStats end
	
	playerWithRock = nil
	rockMobj = P_SpawnMobj(m.x, m.y, m.z, MT_PSSE_THING)
	
	if keepmomentum then
	rockMobj.momx = $ + m.momx
	rockMobj.momy = $ + m.momy
	rockMobj.momz = $ + m.momz
	end
	
	local bumpval = bump and 8*FRACUNIT or 0
	
	if not (m.flags2 & MF2_OBJECTFLIP) then
		rockMobj.flags2 = $ & ~(MF2_OBJECTFLIP)
		rockMobj.momz = $ + bumpval
	else
		rockMobj.flags2 = $|MF2_OBJECTFLIP
		rockMobj.momz = $ - bumpval
	end
	
	--S_StartSound(nil, sfx_pdrop)
	--STATUS_Broadcast("The ^3Master Emerald^0 carrier ^5died^0", 105, 35, nil)
	
	if not cv_globaltimer.value then heldTime = 0 end
	
	if not cv_globaltimer.value and graceMode == 1 and cv_grasptimeMinTime.value < cv_holdtime.value then
		local graceStep = (cv_grasptimeDecrease.value*TICRATE)
		if (cv_holdtime.value*TICRATE) - (graceModeDecrease + graceStep) < (cv_grasptimeMinTime.value*TICRATE) then
		-- if time left substracted by current Grasp time substraction (+ 1 step) is smaller than minimum time allowed by Grasp time substraction
			--(cv_holdtime.value*TICRATE - heldTime)
			graceModeDecrease = (cv_holdtime.value*TICRATE - cv_grasptimeMinTime.value*TICRATE)
			--heldTime = (cv_holdtime.value*TICRATE - cv_grasptimeMinTime.value*TICRATE)
		else
			graceModeDecrease = $ + graceStep
		end
	end
end

addHook("MobjThinker", function(m) -- Player thinker for gametype
	if inPossRound then
		if m.valid and m.player and m.player.valid then
			if playerWithRock == m.player then
				m.health = 1
				m.player.health = 1
				m.player.powers[pw_infinityring] = 0
				m.player.powers[pw_automaticring] = 0
				m.player.powers[pw_bouncering] = 0
				m.player.powers[pw_scatterring] = 0
				m.player.powers[pw_grenadering] = 0
				m.player.powers[pw_explosionring] = 0
				m.player.powers[pw_railring] = 0
				m.player.ringweapons = 0
				m.player.weapondelay = 2
				m.player.powers[pw_shield] = SH_NONE
				
				if not teamPossRound then
					heldTime = $ + 1
				elseif teamPossRound then
					if m.player.ctfteam == 1 then
						heldTime = $ + 1
					elseif m.player.ctfteam == 2 then
						heldTimeBlue = $ + 1
					end
				end
				
				if (m.player.cmd.buttons & (BT_ATTACK|BT_FIRENORMAL)) then STATUS_BroadcastToPlayer(m.player, "^7Voce nao pode atirar\n^7com a Esmeralda", 70, 35, 0) end
				if (m.player.cmd.buttons & BT_TOSSFLAG) then
					local cvar = cv_tossemerald.value
					local function zeroToss()
						STATUS_BroadcastToPlayer(m.player, "^7You can't toss\n^7the Emerald", 70, 35, 0)
					end
					
					if cvar == 0 then
						zeroToss()
						
					elseif cvar == 1 or cvar == 2 then
						print(TCC(m.player)..m.player.name.."\128 largou a \131Esmeralda Mestre\128!")
						STATUS_Broadcast("O transportador largou a\n^3Esmeralda Mestre", 105, 35, nil)
						S_StartSound(nil, sfx_emtoss)
						playerSpawnsEmerald(m, (cvar == 2 and true or false), (cvar == 1 and true or false))
						if cvar == 2 then LaunchRelative(rockMobj, m.angle, m.player.aiming, 16*FRACUNIT) end
						m.player.tossdelay = TICRATE
						
					elseif cvar == 3 then
						zeroToss()
					end
				end
			end
		end
		if ((rockMobj and rockMobj.valid) or (playerWithRock and playerWithRock ~= m.player)) and m.player and m.player.playerstate ~= PST_DEAD then
			if m.toBeepTime == nil then m.toBeepTime = 0 end
			if m.maxBeepTime == nil then m.maxBeepTime = 999 end
			if m.oldmaxBeepTime == nil then m.oldmaxBeepTime = 999 end
			if m.timeSinceBeep == nil then m.timeSinceBeep = 999 end
			
			m.toBeepTime = $ - 1
			m.timeSinceBeep = $ + 1
			if m.toBeepTime > m.maxBeepTime then m.toBeepTime = m.maxBeepTime end
			
			--print(m.toBeepTime)
			--print(m.maxBeepTime)
			
			if m.toBeepTime < 0 then
				m.toBeepTime = m.maxBeepTime
				m.timeSinceBeep = 0
				S_StartSound(nil, sfx_emfind, m.player)
			end
			
			local a = 0
			local nn
			if (rockMobj and rockMobj.valid) then
				nn = rockMobj
			elseif (playerWithRock and playerWithRock.valid and playerWithRock.mo and playerWithRock.mo.valid) then
				nn = playerWithRock.mo
			else
				error("Unable to define nn")
			end
			
			a = R_PointToDist2(R_PointToDist2(m.x, m.y, nn.x, nn.y), m.z, 0, nn.z)
			a = a/FRACUNIT
			a = a/8
			
			local iter,match = 0,0
			local maxIter = 60
			local incDistance = 28 -- 48
			local incBeep = 2 -- 4
			
			if m.oldmaxBeepTime > m.maxBeepTime then -- Don't ask
				m.toBeepTime = $ - incBeep
			end
			if m.oldmaxBeepTime < m.maxBeepTime then -- It's not like the player is fast
				m.toBeepTime = $ + incBeep
			end
			m.oldmaxBeepTime = m.maxBeepTime
			
			repeat
				iter = $ + 1
				if iter < maxIter and a < (iter*incDistance) then
					m.maxBeepTime = incBeep*iter
					match = 1
				end
				if iter >= maxIter then m.maxBeepTime = incBeep*maxIter end
			until iter >= maxIter or match == 1
			--print(m.maxBeepTime)
		end
		
		local function getHeldTime()
			if cv_globaltimer.value == 2 then
				if not playerWithRock then return heldTime end
				local pteam = playerWithRock.ctfteam
				if pteam == 1 then return heldTime
				else return heldTimeBlue end
			else
				return heldTime
			end
		end
		
		local w = ( (cv_holdtime.value*TICRATE - getHeldTime()) / TICRATE )
		local tmod = (getHeldTime()-1) % 35
		if w <= 10 and w >= 0 and (playerWithRock) then
			if (tmod == 0) or (w <= 3 and tmod == 17) then
				S_StartSound(nil, sfx_ptime, m.player)
			end
		end
		
	end
end, MT_PLAYER)
addHook("MobjDamage", function(m, inf, src) -- Override damage by applying instant kill if carrying rock
	if inPossRound and m.player == playerWithRock then
		P_KillMobj(m, inf, src)
		return true
	end
end, MT_PLAYER)

addHook("MobjDeath", function(m, inf, src) -- Player kill thinker for gametype
	if inPossRound and m.player == playerWithRock then
		playerSpawnsEmerald(m, (cv_deathmomentum.value == 1 and true or false), true)
		S_StartSound(nil, sfx_pdrop)
		STATUS_Broadcast("O transportador ^5morreu^0", 105, 35, nil)
	end
end, MT_PLAYER)

addHook("MobjThinker", function(m) -- Possession rock
	m.scale = 2*FRACUNIT
	if inPossRound then
		playerWithRock = nil -- If the rock is in the map, nobody is holding it, naturally!
	else
		P_RemoveMobj(m)
	end
end, MT_PSSE_THING)

addHook("MobjRemoved", function(m)
	if P_CheckDeathPitCollide(m)
		_dummy1 = P_RandomRange(1, #spawnLocations)
		local a = spawnLocations[_dummy1]
		rockMobj = P_SpawnMobj(a.x, a.y, a.z, MT_PSSE_THING)
		print("A \131Esmeralda Mestre\128 apareceu.")
		STATUS_Broadcast("A ^3Esmeralda Mestre^0 ^2apareceu^0", 175, 70, flags)
		S_StartSound(nil, sfx_pret)
		S_StartSound(rockMobj, sfx_pspawn)
		P_RemoveMobj(m)
		return true
	end
end, MT_PSSE_THING)

addHook("ShouldDamage", function(m, inf, src, dmg) -- Possession rock
if cv_shootemerald.value == 1 then
	if src and src.player and inf and (
	inf.type == MT_REDRING or
	inf.type == MT_THROWNBOUNCE or
	inf.type == MT_THROWNINFINITY or
	inf.type == MT_THROWNAUTOMATIC or
	inf.type == MT_THROWNSCATTER or
	inf.type == MT_THROWNEXPLOSION or
	inf.type == MT_THROWNGRENADE
	) then
		if ( inf.type == MT_REDRING and not (inf.flags2 & MF2_RAILRING) ) or inf.type ~= MT_REDRING then
			
			local expEx = -3
			local scaEx = -1
			local greEx = 3
			
			local halveforce = 6 + (inf.type == MT_THROWNEXPLOSION and expEx or 0) + (inf.type == MT_THROWNSCATTER and scaEx or 0) + (inf.type == MT_THROWNGRENADE and greEx or 0)
			local extraforce = 6*FRACUNIT
			
			m.momx = $ + inf.momx/halveforce
			m.momy = $ + inf.momy/halveforce
			m.momz = $ + inf.momz/halveforce
			
			if not (m.eflags & MFE_VERTICALFLIP) then
				m.momz = $ + extraforce
			else
				m.momz = $ - extraforce
			end
			S_StartSound(m, sfx_pemhit)
		end
		return false
	else
		return false
	end
else
	S_StartSound(m, sfx_pemhit)
	return false
end
end, MT_PSSE_THING)

addHook("MobjThinker", function(m) -- Possession rock payer indicator
	m.scale = 3*FRACUNIT
	if inPossRound then -- If we're playing
		if playerWithRock and playerWithRock.valid and playerWithRock.mo then -- Is a player holding the rock?
			local p = playerWithRock.mo
			local shift = 60*FRACUNIT -- We, the indicator, move with the player
			if not (p.flags2 & MF2_OBJECTFLIP) then
				m.eflags = $ & ~MFE_VERTICALFLIP
				P_TeleportMove(m, p.x, p.y, p.z+shift)
			else
				m.eflags = $|MFE_VERTICALFLIP
				P_TeleportMove(m, p.x, p.y, p.z-shift)
			end
			oldPlayerWithRockStats = {
				x = p.x,
				y = p.y,
				z = p.z,
				momx = p.momx,
				momy = p.momy,
				momz = p.momz,
				flags2 = p.flags2,
				eflags = p.eflags
			}
			return
		else -- Otherwise
			if  not (   playerWithRock and    playerWithRock.valid)
			and not (oldPlayerWithRock and oldPlayerWithRock.valid) then
			--if not playerWithRock or not playerWithRock.valid then
				--_dummy1 = P_RandomRange(1, #spawnLocations)
				--local a = spawnLocations[_dummy1]
				--rockMobj = P_SpawnMobj(a.x, a.y, a.z, MT_PSSE_THING)
				--if not cv_globaltimer.value then heldTime = 0 end
				
				playerSpawnsEmerald(nil, true, true)
				print("O transportador saiu da partida. A \131Esmeralda Mestre\128 reapareceu.")
				STATUS_Broadcast("The ^3Master Emerald^0 carrier\n^7left the game", 105, 35, nil)
				S_StartSound(nil, sfx_pdrop)
			end
			P_RemoveMobj(m)
			return
		end
	end
	
	if not inPossRound then -- We're not playing
		P_RemoveMobj(m) -- We don't need this object floating around
	end
end, MT_PSSE_INDICATOR)

addHook("AbilitySpecial", function(player)
	if inPossRound then -- If we're playing
		if playerWithRock == player then -- Are we holding the rock?
			STATUS_BroadcastToPlayer(player, "^7Voce nao pode usar habilidades\n^7com a Esmeralda", 70, 35, 0) -- Let them kno
			return true -- Do not let the player use abilities
		end
	end
end)




addHook("MapChange", function(mapn)
	inPossRound = false
	playerWithRock = nil
	oldPlayerWithRock = nil
	oldPlayerWithRockStats = {}
	rockMobj = nil
	spawnLocations = {}
	heldTime = 0
	heldTimeBlue = 0
	graceMode = 0
	graceModeDecrease = 0
	_endrnd = false
	
	if (cv_possenabled.value == 1) then
		inPossRound = true
		if cv_globaltimer.value == 2 and gametype == GT_TEAMMATCH then
			teamPossRound = true
		else
			teamPossRound = false
		end
	end
	
end)
addHook("HurtMsg", function(hit, inflictor, source)
if hit and hit.valid and source and source.valid then
	local ishepepsi = hit.health >= 1 and "hit" or "killed"
	local name = hit.name
	local teamcolor = TCC(hit)
	teamcolor = teamcolor ~= "\130" and teamcolor or "\128"
	print(teamcolor..name.."\128 levou "..ishepepsi.." da Esmeralda Mestre.")
	return true
end
end, MT_PSSE_THING)


hud.add(function(v, player)
	hud.enable("weaponrings")
	hud.enable("rings")
	if (cv_possenabled.value == 1) and inPossRound then
		local emPatch = v.cachePatch("PSSEA0")
		local upPatch = v.cachePatch("IND090")
		local dnPatch = v.cachePatch("IND270")
		local emxpos = 320-44
		if player.mo then
			
			if not (rockMobj or playerWithRock) then -- Rock hasn't spawned
				v.drawScaled(emxpos*FRACUNIT, (200-12)*FRACUNIT, FRACUNIT/2, emPatch, V_70TRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM)
			else
				if playerWithRock == player then
					v.drawScaled(emxpos*FRACUNIT, (200-12)*FRACUNIT, FRACUNIT/2, emPatch, V_10TRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM)
				else
					local k = player.mo.timeSinceBeep or 0
					local function l()
						if k > 8 then return V_50TRANS
						elseif k > 6 then return V_40TRANS
						elseif k > 4 then return V_30TRANS
						elseif k > 2 then return V_20TRANS
						else return V_10TRANS end
					end
					local n = l()
					v.drawScaled(emxpos*FRACUNIT, (200-12)*FRACUNIT, FRACUNIT/2, emPatch, n|V_SNAPTORIGHT|V_SNAPTOBOTTOM)
				end
			end
			
			if cv_grasptime.value and graceMode == 1 and graceModeDecrease > 0 then
				local graceText = "-"..graceModeDecrease/TICRATE
				local strWidth = v.stringWidth(graceText, nil, "small")/2
				v.drawString(emxpos-strWidth, 200-21, graceText, V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_REDMAP|V_MONOSPACE, "small")
			end
			
			if (rockMobj and rockMobj.valid) or (playerWithRock and playerWithRock ~= player) then
				local mobj
				if (rockMobj and rockMobj.valid) then mobj = rockMobj
				elseif (playerWithRock and playerWithRock.valid and playerWithRock.mo and playerWithRock.mo.valid) then mobj = playerWithRock.mo end
				if not mobj then return end -- Failsafe for 1 tic or so
				local zp = player.mo.z
				local zm = mobj.z
				local heightval = 0
				
				if     zp > zm and zp - zm >  120*FRACUNIT then heightval = 1
				elseif zp < zm and zp - zm < -120*FRACUNIT then heightval = -1 end
				
				if (player.mo.flags2 & MF2_OBJECTFLIP) then heightval = -heightval end
				
				
				local k = player.mo.timeSinceBeep or 0
				local function l()
					if k > 8 then return V_50TRANS
					elseif k > 6 then return V_40TRANS
					elseif k > 4 then return V_30TRANS
					elseif k > 2 then return V_20TRANS
					else return V_10TRANS end
				end
				local n = l()
				
				local a = heightval == 1 and dnPatch or heightval == -1 and upPatch or nil
				
				if a then
					v.drawScaled(emxpos*FRACUNIT, (200-12)*FRACUNIT, FRACUNIT/2, a, V_60TRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM)
				end
			end
			
			-- Timer
			if playerWithRock or cv_globaltimer.value then
			if cv_globaltimer.value <= 1 or not teamPossRound then
				local wa = ( (cv_holdtime.value*TICRATE - heldTime) / TICRATE )
				local timerColor = V_GRAYMAP
				--if cv_globaltimer.value then timerColor = V_ORANGEMAP end
				if playerWithRock then
					timerColor = V_YELLOWMAP
					if wa <= 10 and wa >= 0 and (heldTime-1) % 35 > 17 then timerColor = V_REDMAP end
					if wa < 0 then timerColor = V_GRAYMAP end
				end
				if wa < 0 then wa = 0 end
				v.drawString(emxpos, 200-29, wa, V_SNAPTORIGHT|V_SNAPTOBOTTOM|timerColor|V_MONOSPACE, "center")
			elseif cv_globaltimer.value == 2 and teamPossRound then
				
				local waR = ( (cv_holdtime.value*TICRATE - heldTime) / TICRATE )
				local waB = ( (cv_holdtime.value*TICRATE - heldTimeBlue) / TICRATE )
				
				local timerColorR = V_GRAYMAP
				local timerColorB = V_GRAYMAP
				
				if playerWithRock then
					timerColorR = V_YELLOWMAP
					timerColorB = V_YELLOWMAP
					
					if waR <= 10 and waB >= 0 and (heldTime-1) % 35 > 17 then timerColorR = V_REDMAP end
					if waR < 0 then timerColorR = V_GRAYMAP end
					
					if waR <= 10 and waB >= 0 and (heldTimeBlue-1) % 35 > 17 then timerColorB = V_REDMAP end
					if waR < 0 then timerColorB = V_GRAYMAP end
				end
				if waR < 0 then waR = 0 end
				if waB < 0 then waB = 0 end
				
				
				--vREDMAP was timerColor
				v.drawString(emxpos, 200-29-4, waR, V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_REDMAP|V_MONOSPACE, "center")
				v.drawString(emxpos, 200-29+4, waB, V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_BLUEMAP|V_MONOSPACE, "center")
				
			end
			
			end
			
			if playerWithRock then -- >start PlayerWithRock
			-- Name
			local temcol = playerWithRock.ctfteam == 1 and V_REDMAP or playerWithRock.ctfteam == 2 and V_BLUEMAP or V_PURPLEMAP
			local ffacol = playerWithRock == player and V_GREENMAP or V_REDMAP
			local col = G_GametypeHasTeams() and temcol or ffacol
			local strWidth = v.stringWidth(playerWithRock.name, nil, "small")/2
			local teamY = teamPossRound and 4 or 0
			v.drawString(emxpos-strWidth, 200-33-teamY, playerWithRock.name, V_SNAPTORIGHT|V_SNAPTOBOTTOM|col|V_MONOSPACE|V_ALLOWLOWERCASE, "small")
			
			if playerWithRock == player and playerWithRock.mo and playerWithRock.valid then
				hud.disable("weaponrings")
				hud.disable("rings")
				v.draw(17, 44, v.cachePatch("PSSERNGS"), V_HUDTRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
				v.draw(304, 24, v.cachePatch("NOSDA0"), V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			end
			
			end -- >end playerWithRock
		end
		
		if (cv_holdtime.value*TICRATE - heldTime) < -3*FRACUNIT then
			v.drawString(8, 200-48, "exitlevel error", V_SNAPTOLEFT)
		end
	end
end, "game")

