-- Status thing
-- At the center of the screen probably?

-- Defaults
local const_livetime = 6*TICRATE
-- Amount of time for message
local const_fadetime = 3*TICRATE
-- Moment where message starts fading

local function doStatus(player, msg, livetime, fadetime, flags)
	
	local msgs = {}
	
	--print("Start snip")
	local iter = 0
	local iterdone = false
	repeat
		iter = $ + 1
		--print("msg \""..msg.."\"")
		--print("searching \n")
		local s,e = string.find(msg, "\n")
		--print("s e "..(s~=nil and s or "nil").." "..(e~=nil and e or "nil").."")
		local msglen = string.len(msg)
		--print("len "..(msglen or "nil"))
		
		if s and s-1 >= 1 and e and e+1 <= msglen then
			local leftsnip = string.sub(msg, 1, s-1)
			local rightsnip = string.sub(msg, e+1)
			table.insert(msgs, leftsnip)
			msg = rightsnip
		else
			table.insert(msgs, msg)
			iterdone = true
		end
	until iter == 10 or iterdone
	--print("End snip")
	
	
	--print("---- statusing")
	livetime = tonumber(livetime)
	fadetime = tonumber(fadetime)
	flags = tonumber(flags)
	
	local block = {}
	block.msgs = msgs and #msgs and msgs or {"No message (error)"}
	--print(block.msgs)
	--print(#block.msgs)
	block.livetime = livetime ~= nil and livetime or const_livetime
	--print(block.livetime)
	block.curtime = block.livetime
	--print(block.curtime)
	block.fadetime = fadetime ~= nil and fadetime or const_fadetime
	--print(block.fadetime)
	block.flags = flags or 0
	--print(block.flags)
	block.exist = true
	--print(block.exist)
	player.currentStatus = block
	--print("---- Feedback message added")
end

local function STATUS_Broadcast(msg, livetime, fadetime, flags)
	for player in players.iterate do
	if player and player.valid then
		--print("> You called?")
		doStatus(player, msg, livetime, fadetime, flags)
		--print("> passed")
	end
	end
end
local function STATUS_BroadcastToPlayer(player, msg, livetime, fadetime, flags)
	if player and player.valid then
		doStatus(player, msg, livetime, fadetime, flags)
	end
end
rawset(_G, "STATUS_Broadcast", STATUS_Broadcast)
rawset(_G, "STATUS_BroadcastToPlayer", STATUS_BroadcastToPlayer)

addHook("ThinkFrame", function()
for player in players.iterate do
if player and player.valid then

	if player.currentStatus == nil then
		player.currentStatus = {msgs = nil,livetime = 0,curtime = 0,fadetime = 0,flags = 0,exist = false}
		--print("status init")
	end
	
	if player.currentStatus then --failsafe lol
		local item = player.currentStatus
		
		if item and item.exist and item.msgs ~= nil and #item.msgs > 0 and item.livetime ~= nil and item.curtime ~= nil then
			--print("Doing it 2")
			
			if item.curtime == 0 then
				--print("item doesn't exist anymore")
				item.exist = false
			end
			
			if item.curtime > 0 then item.curtime = $ - 1 end
			
		end
		
	end

end
end
end)


hud.add( function(v, p, c)
if p and p.valid then
if p.currentStatus then
	
	local function getShift(txt)
		txt = tostring(txt)
		--print("Submitted text: "..txt)
		--print("LEN "..string.len(txt))
		txt = string.gsub(txt, "(%^%d)", "")
		txt = string.gsub(txt, "\n", "")
		--print("Formatted text: "..txt)
		--print("LEN "..string.len(txt))
		local txtlen = string.len(txt)*8
		return txtlen/2
	end
	
	if p.currentStatus and p.currentStatus.exist then
		local item = p.currentStatus
		local itime = item.curtime or 0
		--local extraflags = item.flags or 0
		local extraflags = 0
		
		local transflags = 0
		local tfade = item.fadetime
		    if itime < (tfade/10)*1 then transflags = V_90TRANS
		elseif itime < (tfade/10)*2 then transflags = V_80TRANS
		elseif itime < (tfade/10)*3 then transflags = V_70TRANS
		elseif itime < (tfade/10)*4 then transflags = V_60TRANS
		elseif itime < (tfade/10)*5 then transflags = V_50TRANS
		elseif itime < (tfade/10)*6 then transflags = V_40TRANS
		elseif itime < (tfade/10)*7 then transflags = V_30TRANS
		elseif itime < (tfade/10)*8 then transflags = V_20TRANS
		elseif itime < (tfade/10)*9 then transflags = V_10TRANS
		else transflags = 0 end
		
		local shiftValues = {}
		local msgsmod = {}
		if item.msgs and #item.msgs then
		for i = 1,#item.msgs do
			local a = item.msgs[i]
			local q = getShift(a)
			shiftValues[i] = q
			a = string.gsub(a, "(%^0)", "\x80")
			a = string.gsub(a, "(%^1)", "\x81")
			a = string.gsub(a, "(%^2)", "\x82")
			a = string.gsub(a, "(%^3)", "\x83")
			a = string.gsub(a, "(%^4)", "\x84")
			a = string.gsub(a, "(%^5)", "\x85")
			a = string.gsub(a, "(%^6)", "\x86")
			a = string.gsub(a, "(%^7)", "\x87")
			msgsmod[i] = a
		end
		end
		-- if itime is 32
		-- and livetime is 35
		-- then
		--    extraY = 32    > 35            - 4 and 4-(35            - 32   ) or 0
		
		local extraY = itime > item.livetime - 4 and 4-(item.livetime - itime) or 0
		
		--local messagearray = {}
		
		for index,message in ipairs(msgsmod) do
			local totalmsgs = #item.msgs
			
			--local     msgX  =  160 - getShift(message or "error")
			local     msgX  =  160 - (shiftValues[index] or 0)
			local     msgY  =  190 - extraY - ((#item.msgs-1)*8) + ((index-1)*8)
			local   msgMSG  =  message or "error"
			local msgFLAGS  =  V_SNAPTOBOTTOM|V_MONOSPACE|V_ALLOWLOWERCASE|extraflags|transflags
			
			v.drawString(msgX, msgY, msgMSG, msgFLAGS)
		end
		
		
		--v.drawString(160-getShift(item.msg or "error"), 200-10-extraY, modmsg or "error", V_SNAPTOBOTTOM|V_MONOSPACE|V_ALLOWLOWERCASE|extraflags|transflags)
		--print("Drawing!? "..itime)
	end
	
end
end
end, "game")

--[[
COM_AddCommand("feed_broadcast", function(p, msg)
	print("Broadcasting")
	STATUS_Broadcast(msg)
	print("Broadcasted")
end, 1)
COM_AddCommand("feed_broadcast2", function(p, msg, livetime, fadetime, flags)
	print("Broadcasting")
	STATUS_Broadcast(msg, livetime, fadetime, flags)
	print("Broadcasted")
end, 1)
]]